<?php 

/*  Demonstration on using authorizenet.class.php.  This just sets up a 
*  little test transaction to the authorize.net payment gateway.  You 
*  should read through the AIM documentation at authorize.net to get 
*  some familiarity with what's going on here.  You will also need to have 
*  a login and password for an authorize.net AIM account and PHP with SSL and 
*  curl support. 
* 
*  Reference http://www.authorize.net/support/AIM_guide.pdf for details on 
*  the AIM API. 
*/  
require_once("simdata.php");
require_once('authorizenet.class.php'); 

$a = new authorizenet_class($test); 
// You login using your login, login and tran_key, or login and password.  It 
// varies depending on how your account is setup. 
// I believe the currently reccomended method is to use a tran_key and not 
// your account password.  See the AIM documentation for additional information. 

$a->add_field('x_login', $login); 
$a->add_field('x_tran_key', $transkey); 
//$a->add_field('x_password', 'CHANGE THIS TO YOUR PASSWORD'); 

$a->add_field('x_version', '3.1'); 
$a->add_field('x_type', 'AUTH_CAPTURE'); 
$a->add_field('x_test_request', $test);    // Just a test transaction 
$a->add_field('x_relay_response', 'FALSE'); 

// You *MUST* specify '|' as the delim char due to the way I wrote the class. 
// I will change this in future versions should I have time.  But for now, just 
// make sure you include the following 3 lines of code when using this class. 

$a->add_field('x_delim_data', 'TRUE'); 
$a->add_field('x_delim_char', '|');      
$a->add_field('x_encap_char', ''); 


// Setup fields for customer information.  This would typically come from an 
// array of POST values froma secure HTTPS form. 

$a->add_field('x_first_name', $_POST['x_first_name']); 
$a->add_field('x_last_name', $_POST['x_last_name']); 
$a->add_field('x_address', $_POST['x_address']); 
$a->add_field('x_city', $_POST['x_city']); 
$a->add_field('x_state', $_POST['x_state']); 
$a->add_field('x_zip', $_POST['x_zip']); 
$a->add_field('x_country', $_POST['x_country']); 
$a->add_field('x_email', $_POST['x_email']); 
$a->add_field('x_phone', $_POST['x_phone']); 


// Using credit card number '4007000000027' performs a successful test.  This 
// allows you to test the behavior of your script should the transaction be 
// successful.  If you want to test various failures, use '4222222222222' as 
// the credit card number and set the x_amount field to the value of the 
// Response Reason Code you want to test.  
// 
// For example, if you are checking for an invalid expiration date on the 
// card, you would have a condition such as: 
// if ($a->response['Response Reason Code'] == 7) ... (do something) 
// 
// Now, in order to cause the gateway to induce that error, you would have to 
// set x_card_num = '4222222222222' and x_amount = '7.00' 

//  Setup fields for payment information 
$a->add_field('x_method', 'CC'); 
$a->add_field('x_card_num', $_POST['x_card_num']);   // test successful visa 
if($_REQUEST['trial_amount'])
{
	$a->add_field('x_amount', $_REQUEST['trial_amount']); //$_POST['x_amount'];
}
else
{
$a->add_field('x_amount', $_REQUEST['amount']); //$_POST['x_amount'];
}
$a->add_field('x_exp_date', $_POST['x_exp_date']);    // march of 2008 
$a->add_field('x_card_code', $_POST['x_card_code']);    // Card CAVV Security code 


// Process the payment and output the results 
switch ($a->process()) { 

   case 1:  // Successs 
    
	 if($test)
	  {
		$keychars = "abcdefghijklmnopqrstuvwxyz0123456789";
		$length = 10;
		//RANDOM KEY GENERATOR
		$randkey = "";
		for ($i=0;$i<$length;$i++)
		$txn_id .= substr($keychars, rand(0, strlen($keychars)-1 ), 1);
		//Note: This txn id will be generate by in case of test payment because test payment doesnot give any txn_id.
	  }
	  else
	  {
		  $txn_id=$a->response['x_trans_id'];
	  }

	$passback .="&pay_success=true&pay_mode=authorize.net&hash_id=".$_REQUEST['x_hash_id']."&trial_amount=".$_REQUEST['trial_amount']."&amount=".$a->response['x_amount']."&mode=".$_REQUEST['mode']."&txn_id=". $txn_id;
	$submit_url="$DomainName/returnAPI.php?".$passback;
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $submit_url);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $passback);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	$answer = curl_exec($ch);
	$curlErr = curl_error($ch);
	curl_close($ch);
	header("location: $DomainName/members/regnSuccess.php");
	exit;
  break; 
      
   case 2:  // Declined 
		$passback .="&pay_success=false&pay_mode=authorize.net&hash_id=".$_REQUEST['x_hash_id']."&trial_amount=".$_REQUEST['trial_amount']."&amount=".$a->response['x_amount']."&mode=".$_REQUEST['mode']."&txn_id=". $txn_id;
		$submit_url="$DomainName/returnAPI.php?".$passback;

		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $submit_url);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $passback);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$answer = curl_exec($ch);
		$curlErr = curl_error($ch);
		curl_close($ch);
		$message="<b>Declined Payment Notification from Authorize.net</b><br /><br />";
		$message.="Authorize.net appended below:\n\n";
		$message.=$a->get_response_reason_text().$a->dump_response().$a->dump_fields();
		$a->SKMail('Authorize.net INS Data', $message, $Attachments, $webmasterEmail, $webmasterEmail, $MailType='H');
		header("location: $DomainName/members/regnFailed.php");
		break; 
      
   case 3:  // Error 

		$passback .="&pay_success=false&pay_mode=authorize.net&hash_id=".$_REQUEST['x_hash_id']."&trial_amount=".$_REQUEST['trial_amount']."&amount=".$a->response['x_amount']."&mode=".$_REQUEST['mode']."&txn_id=". $txn_id;
		$submit_url="$DomainName/returnAPI.php?".$passback;
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $submit_url);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $passback);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$answer = curl_exec($ch);
		$curlErr = curl_error($ch);
		curl_close($ch);
		$message="<b>Error with Transaction:</b>\n\n";
		$message.="Authorize.net appended below:\n\n";
		$message.=$a->get_response_reason_text().$a->dump_response().$a->dump_fields();
		$a->SKMail('Authorize.net INS Data', $message, $Attachments, $webmasterEmail, $webmasterEmail, $MailType='H');
		header("location: $DomainName/members/regnFailed.php");
		break; 
  } 
?>

