<?php

define('OBJECT', 'OBJECT', true);
define('ARRAY_A', 'ARRAY_A', false);
define('ARRAY_N', 'ARRAY_N', false);

if (!defined('SAVEQUERIES'))
	define('SAVEQUERIES', false);


define('ROWS_PER_SEGMENT', 100);

class backup
{
	var $backup_complete = false;
	var $backup_file = '';
	var $backup_dir = BACKUP_DIR;
	var $backup_errors = array();
	var $basename;
	var $core_tbl_array;
	var $result;
	var $last_result;
	var $col_info ;
	var $last_query;
	var $dbObj;

	function backup($core_table_array, $db)
	{
		$this->dbObj=&$db;
		$this->core_tbl_array=$core_table_array;
	}


	function gzip() {
		return function_exists('gzopen');
	}

	

	function backup_fragment($table, $segment, $filename) {
		global $table_prefix;
		$table_prefix = db_tblprefix;
		echo "$table:$segment:$filename";
		
		if($table == '') {
			$msg = 'Creating backup file...';
		} else {
			if($segment == -1) {
				$msg = sprintf('Finished backing up table \\"%s\\".', $table);
			} else {
				$msg = sprintf('Backing up table \\"%s\\"...', $table);
			}
		}
		
		echo '<script type="text/javascript"><!--//
		var msg = "' . $msg . '";
		window.parent.setProgress(msg);
		';
			
		if (is_writable(ABSPATH . $this->backup_dir)) {
			$this->fp = $this->open(ABSPATH . $this->backup_dir ."/". $filename, 'a');
			if(!$this->fp) {
				$this->backup_error = 'Could not open the backup file for writing!';
				$this->fatal_error = 'The backup file could not be saved.  Please check the permissions for writing to your backup directory and try again.';
			}
			else {
				if($table == '') {		
					//Begin new backup of MySql
					$this->stow("# WordPress MySQL database backup\n");
					$this->stow("#\n");
					$this->stow("# Generated: " . date("l j. F Y H:i T") . "\n");
					$this->stow("# Hostname: " . DB_HOST . "\n");
					$this->stow("# Database: " . $this->backquote(db_database) . "\n");
					$this->stow("# --------------------------------------------------------\n");
				} else {
					if($segment == 0) {
						// Increase script execution time-limit to 15 min for every table.
						if ( !ini_get('safe_mode')) @set_time_limit(15*60);
						//ini_set('memory_limit', '16M');
						// Create the SQL statements
						$this->stow("# --------------------------------------------------------\n");
						$this->stow("# Table: " . $this->backquote($table) . "\n");
						$this->stow("# --------------------------------------------------------\n");
					}			
					$this->backup_table($table, $segment);
				}
			}
		} else {
			$this->backup_error('The backup directory is not writeable!');
			$this->fatal_error = 'The backup directory is not writeable!  Please check the permissions for writing to your backup directory and try again.';
		}

		if($this->fp) $this->close($this->fp);
		
		if($this->backup_errors) {
			foreach($this->backup_errors as $error) {
				echo "window.parent.addError('$error');\n";
			}
		}
		if($this->fatal_error) {
			echo '
				alert("' . addslashes($this->fatal_error) . '");
				//--></script>
			';
		}
		else {
			echo '
				window.parent.nextStep();
				//--></script>
			';
		}
		
		die();
	}

	function perform_backup() {
		$core_tables = $this->core_tbl_array;
		$this->backup_file = $this->db_backup($core_tables, $also_backup);
		if (FALSE !== $this->backup_file) {
			if ('smtp' == $_POST['deliver']) {
				$this->deliver_backup ($this->backup_file, $_POST['deliver'], $_POST['backup_recipient']);
			} elseif ('http' == $_POST['deliver']) {
				//$this->deliver_backup ($this->backup_file, $_POST['deliver']);
				sleep(2);
				//header("Location: ".PHP_SELF);
			}
			// we do this to say we're done.
			$this->backup_complete = true;
		}
	}

	function perform_backup_cron($other_tables) 
	{
		// are we backing up any other tables?
		$also_backup = array();
		$other_table_yes = $this->dbObj->GetAppVar("VARBackupOtherTbls");
		if (isset($other_tables) && $other_table_yes==1) 
		{
			$also_backup = $other_tables;
		}
		
		$core_tables = $this->core_tbl_array;
		$this->backup_file = $this->db_backup($core_tables, $also_backup);
		if (FALSE !== $this->backup_file) 
		{
			$this->deliver_backup ($this->backup_file, "cron");
		}

			// we do this to say we're done.
			$this->backup_complete = true;
		
	}
	
	
	/////////////////////////////////////////////////////////
	function sql_addslashes($a_string = '', $is_like = FALSE)
	{
	        /*
	                Better addslashes for SQL queries.
	                Taken from phpMyAdmin.
	        */
	    if ($is_like) {
	        $a_string = str_replace('\\', '\\\\\\\\', $a_string);
	    } else {
	        $a_string = str_replace('\\', '\\\\', $a_string);
	    }
	    $a_string = str_replace('\'', '\\\'', $a_string);

	    return $a_string;
	} // function sql_addslashes($a_string = '', $is_like = FALSE)

	///////////////////////////////////////////////////////////
	function backquote($a_name)
	{
	        /*
	                Add backqouotes to tables and db-names in
	                SQL queries. Taken from phpMyAdmin.
	        */
	    if (!empty($a_name) && $a_name != '*') {
	        if (is_array($a_name)) {
	             $result = array();
	             reset($a_name);
	             while(list($key, $val) = each($a_name)) {
	                 $result[$key] = '`' . $val . '`';
	             }
	             return $result;
	        } else {
	            return '`' . $a_name . '`';
	        }
	    } else {
	        return $a_name;
	    }
	} // function backquote($a_name, $do_it = TRUE)

	/////////////
	function open($filename = '', $mode = 'w') {
		if ('' == $filename) return false;
		if ($this->gzip()) {
			$fp = @gzopen($filename, $mode);
		} else {
			$fp = @fopen($filename, $mode);
		}
		return $fp;
	}

	//////////////
	function close($fp) {
		if ($this->gzip()) {
			gzclose($fp);
		} else {
			fclose($fp);
		}
	}
	
	//////////////
	function stow($query_line) {
		if ($this->gzip()) {
			if(@gzwrite($this->fp, $query_line) === FALSE) {
				backup_error('There was an error writing a line to the backup script:');
				backup_error('&nbsp;&nbsp;' . $query_line);
			}
		} else {
			if(@fwrite($this->fp, $query_line) === FALSE) {
				backup_error('There was an error writing a line to the backup script:');
				backup_error('&nbsp;&nbsp;' . $query_line);
			}
		}
	}
	
	function backup_error($err) {
		if(count($this->backup_errors) < 20) {
			$this->backup_errors[] = $err;
		} elseif(count($this->backup_errors) == 20) {
			$this->backup_errors[] = 'Subsequent errors have been omitted from this log.';
		}
	}
	
	/////////////////////////////
	function backup_table($table, $segment = 'none') {
		
		
		/*
		Taken partially from phpMyAdmin and partially from
		Alain Wolf, Zurich - Switzerland
		Website: http://restkultur.ch/personal/wolf/scripts/db_backup/
		
		Modified by Scott Merril (http://www.skippy.net/) 
		to use the WordPress $this object
		*/

		$table_structure = $this->get_results("DESCRIBE $table");
		if (! $table_structure) {
			$this->backup_errors[]='Error getting table details' . ": $table";
			
			return FALSE;
		}
	
		if(($segment == 'none') || ($segment == 0)) {
			//
			// Add SQL statement to drop existing table
			$this->stow("\n\n");
			$this->stow("#\n");
			$this->stow("# Delete any existing table " . $this->backquote($table) . "\n");
			$this->stow("#\n");
			$this->stow("\n");
			$this->stow("DROP TABLE IF EXISTS " . $this->backquote($table) . ";\n");
			
			// 
			//Table structure
			// Comment in SQL-file
			$this->stow("\n\n");
			$this->stow("#\n");
			$this->stow("# Table structure of table " . $this->backquote($table) . "\n");
			$this->stow("#\n");
			$this->stow("\n");
			
			$create_table = $this->get_results("SHOW CREATE TABLE $table", ARRAY_N);
			if (FALSE === $create_table) {
				$this->backup_error(sprintf("Error with SHOW CREATE TABLE for %s.", $table));
				$this->stow("#\n# Error with SHOW CREATE TABLE for $table!\n#\n");
			}
			$this->stow($create_table[0][1] . ' ;');
			
			if (FALSE === $table_structure) {
				$this->backup_error(sprintf("Error getting table structure of %s", $table));
				$this->stow("#\n# Error getting table structure of $table!\n#\n");
			}
		
			//
			// Comment in SQL-file
			$this->stow("\n\n");
			$this->stow("#\n");
			$this->stow('# Data contents of table ' . $this->backquote($table) . "\n");
			$this->stow("#\n");
		}
		
		if(($segment == 'none') || ($segment >= 0)) {
			$ints = array();
			foreach ($table_structure as $struct) {
				if ( (0 === strpos($struct->Type, 'tinyint')) ||
					(0 === strpos(strtolower($struct->Type), 'smallint')) ||
					(0 === strpos(strtolower($struct->Type), 'mediumint')) ||
					(0 === strpos(strtolower($struct->Type), 'int')) ||
					(0 === strpos(strtolower($struct->Type), 'bigint')) ||
					(0 === strpos(strtolower($struct->Type), 'timestamp')) ) {
						$ints[strtolower($struct->Field)] = "1";
				}
			}
			
			
			// Batch by $row_inc
			
			if($segment == 'none') {
				$row_start = 0;
				$row_inc = ROWS_PER_SEGMENT;
			} else {
				$row_start = $segment * ROWS_PER_SEGMENT;
				$row_inc = ROWS_PER_SEGMENT;
			}
			
			do {	
				if ( !ini_get('safe_mode')) @set_time_limit(15*60);
				$table_data = $this->get_results("SELECT * FROM $table LIMIT {$row_start}, {$row_inc}", ARRAY_A);
					
				$entries = 'INSERT INTO ' . $this->backquote($table) . ' VALUES (';	
				//    \x08\\x09, not required
				$search = array("\x00", "\x0a", "\x0d", "\x1a");
				$replace = array('\0', '\n', '\r', '\Z');
				if($table_data) {
					foreach ($table_data as $row) {
						$values = array();
						foreach ($row as $key => $value) {
							if ($ints[strtolower($key)]) {
								if($value==NULL)
								{
									$value="NULL";
								}
								$values[] = $value;
							} else {
								$values[] = "'" . str_replace($search, $replace, $this->sql_addslashes($value)) . "'";
							}
						}
						$this->stow(" \n" . $entries . implode(', ', $values) . ') ;');
					}
					$row_start += $row_inc;
				}
			} while((count($table_data) > 0) and ($segment=='none'));
		}
		
		
		if(($segment == 'none') || ($segment < 0)) {
			// Create footer/closing comment in SQL-file
			$this->stow("\n");
			$this->stow("#\n");
			$this->stow("# End of data contents of table " . $this->backquote($table) . "\n");
			$this->stow("# --------------------------------------------------------\n");
			$this->stow("\n");
		}
		
	} // end backup_table()
	
	function return_bytes($val) {
	   $val = trim($val);
	   $last = strtolower($val{strlen($val)-1});
	   switch($last) {
	       // The 'G' modifier is available since PHP 5.1.0
	       case 'g':
	           $val *= 1024;
	       case 'm':
	           $val *= 1024;
	       case 'k':
	           $val *= 1024;
	   }
	
	   return $val;
	}
	
	////////////////////////////
	function db_backup($core_tables, $other_tables) {
		global $table_prefix;
		$datum = date("Ymd_His");
		$wp_backup_filename = DBNAME . "_$datum.sql";
			if ($this->gzip()) {
				$wp_backup_filename .= '.gz';
			}
		if (is_writable($this->backup_dir)) {
			$this->fp = $this->open($this->backup_dir ."/". $wp_backup_filename);
			if(!$this->fp) {
				$this->backup_error('Could not open the backup file for writing!');
				return false;
			}
		} else {
			$this->backup_error('The backup directory is not writeable!');
			return false;
		}
		
		//Begin new backup of MySql
		$this->stow("# Article Manager MySQL database backup\n");
		$this->stow("#\n");
		$this->stow("# Generated: " . date("l j. F Y H:i T") . "\n");
		$this->stow("# Hostname: " . DBHOST . "\n");
		$this->stow("# Database: " . $this->backquote(DBNAME) . "\n");
		$this->stow("# --------------------------------------------------------\n");
		$tables = $core_tables;
		
		foreach ($tables as $table) {
			// Increase script execution time-limit to 15 min for every table.
			if ( !ini_get('safe_mode')) @set_time_limit(15*60);
			// Create the SQL statements
			$this->stow("# --------------------------------------------------------\n");
			$this->stow("# Table: " . $this->backquote($table) . "\n");
			$this->stow("# --------------------------------------------------------\n");
			$this->backup_table($table);
		}
				
		$this->close($this->fp);
		
		if (count($this->backup_errors)) {
			return false;
		} else {
			return $wp_backup_filename;
		}
		
	} //wp_db_backup
	
	///////////////////////////
	function deliver_backup ($filename = '', $delivery = 'http', $recipient = '') {
		if ('' == $filename) { return FALSE; }
		$diskfile = $this->backup_dir ."/". $filename;
		if ('http' == $delivery) {
			if (! file_exists($diskfile)) {
				$msg = sprintf('File not found:%s', "<br /><strong>$filename</strong><br />");
				$this_basename = preg_replace('/^.*wp-content[\\\\\/]plugins[\\\\\/]/', '', __FILE__);
				$msg .= "<br /><a href='backup.php?module_name=".$_GET["module_name"] . "'> Return to Backup";
			die($msg);
			}
			else
			{
				header('Content-Description: File Transfer');
				header('Content-Type: application/octet-stream');
				header('Content-Length: ' . filesize($diskfile));
				header("Content-Disposition: attachment; filename=$filename");
				readfile($diskfile);
				unlink($diskfile);
			}
		}
		return;
	}
	
	////////////////////////////
	function query_flush() 
	{
		$this->last_result = null;
		$this->col_info = null;
		$this->last_query = null;
	}
	
function query($query, $dbObj)
	{
		// initialise return
		$return_val = 0;
		$this->query_flush();

		// Log how the function was called
		

		// Keep track of the last query for debug..
		

		// Perform the query via std mysql_query function..
		$this->result = mysql_query($query, $dbObj);
		
		// If there is an error then take note of it..
		if ( mysql_error() ) {
			$this->print_error();
			return false;
		}

		if ( preg_match("/^\\s*(insert|delete|update|replace) /i",$query) ) {
			$this->rows_affected = mysql_affected_rows();
			// Take note of the insert_id
			if ( preg_match("/^\\s*(insert|replace) /i",$query) ) {
				$this->insert_id = mysql_insert_id($dbObj);	
			}
			// Return number of rows affected
			$return_val = $this->rows_affected;
		} else {
			$i = 0;
			while ($i < @mysql_num_fields($this->result)) {
				
				$this->col_info[$i] = @mysql_fetch_field($this->result);
				$i++;
			}
			$num_rows = 0;
			while ( $row = @mysql_fetch_object($this->result) ) {
				$this->last_result[$num_rows] = $row;
				$num_rows++;
			}

			@mysql_free_result($this->result);

			// Log number of rows the query returned
			$this->num_rows = $num_rows;
			
			// Return number of rows selected
			$return_val = $this->num_rows;
		}

		return $return_val;
	}

function get_results($query = null, $output = OBJECT) 
	{
		
		
		if ( $query )
			$this->query($query, $this->dbObj);

		// Send back array of objects. Each row is an object
		if ( $output == OBJECT ) {
			return $this->last_result;
		} elseif ( $output == ARRAY_A || $output == ARRAY_N ) {
			if ( $this->last_result ) {
				$i = 0;
				foreach( $this->last_result as $row ) {
					$new_array[$i] = (array) $row;
					if ( $output == ARRAY_N ) {
						$new_array[$i] = array_values($new_array[$i]);
					}
					$i++;
				}
				return $new_array;
			} else {
				return null;
			}
		}
	}

}
?>