function strpos (haystack, needle, offset) {
    var i = (haystack+'').indexOf(needle, (offset || 0));
    return i === -1 ? false : i;
}

function explode (delimiter, string, limit) {
     var emptyArray = { 0: '' };
    
    // third argument is not required
    if ( arguments.length < 2 ||
        typeof arguments[0] == 'undefined' ||        typeof arguments[1] == 'undefined' ) {
        return null;
    }
 
    if ( delimiter === '' ||        delimiter === false ||
        delimiter === null ) {
        return false;
    }
     if ( typeof delimiter == 'function' ||
        typeof delimiter == 'object' ||
        typeof string == 'function' ||
        typeof string == 'object' ) {
        return emptyArray;    }
 
    if ( delimiter === true ) {
        delimiter = '1';
    }    
    if (!limit) {
        return string.toString().split(delimiter.toString());
    } else {
        // support for limit argument        var splitted = string.toString().split(delimiter.toString());
        var partA = splitted.splice(0, limit - 1);
        var partB = splitted.join(delimiter.toString());
        partA.push(partB);
        return partA;    }
}

function base64_decode( data ) {
    // http://kevin.vanzonneveld.net
    // +   original by: Tyler Akins (http://rumkin.com)
    // +   improved by: Thunder.m
    // +      input by: Aman Gupta
    // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)    
    // -    depends on: utf8_decode
    // *     example 1: base64_decode('S2V2aW4gdmFuIFpvbm5ldmVsZA==');
    // *     returns 1: 'Kevin van Zonneveld'
    
    // mozilla has this native 
    // - but breaks in 2.0.0.12!
    //if (typeof window['btoa'] == 'function') {
    //    return btoa(data);
    //}
    
    var b64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
    var o1, o2, o3, h1, h2, h3, h4, bits, i = ac = 0, dec = "", tmp_arr = [];
 
    do {  // unpack four hexets into three octets using index points in b64
        h1 = b64.indexOf(data.charAt(i++));
        h2 = b64.indexOf(data.charAt(i++));
        h3 = b64.indexOf(data.charAt(i++));
        h4 = b64.indexOf(data.charAt(i++));
 
        bits = h1<<18 | h2<<12 | h3<<6 | h4;
 
        o1 = bits>>16 & 0xff;
        o2 = bits>>8 & 0xff;
        o3 = bits & 0xff;
 
        if (h3 == 64) {
            tmp_arr[ac++] = String.fromCharCode(o1);
        } else if (h4 == 64) {
            tmp_arr[ac++] = String.fromCharCode(o1, o2);
        } else {
            tmp_arr[ac++] = String.fromCharCode(o1, o2, o3);
        }
    } while (i < data.length);
    
    dec = tmp_arr.join('');
    dec = utf8_decode(dec);
    
    return dec;
}

function utf8_decode ( str_data ) {
    // http://kevin.vanzonneveld.net
    // +   original by: Webtoolkit.info (http://www.webtoolkit.info/)
    // +      input by: Aman Gupta
    // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // *     example 1: utf8_decode('Kevin van Zonneveld');
    // *     returns 1: 'Kevin van Zonneveld'
 
    var tmp_arr = [], i = ac = c = c1 = c2 = 0;
 
    while ( i < str_data.length ) {
        c = str_data.charCodeAt(i);
        if (c < 128) {
            tmp_arr[ac++] = String.fromCharCode(c); 
            i++;
        } else if ((c > 191) && (c < 224)) {
            c2 = str_data.charCodeAt(i+1);
            tmp_arr[ac++] = String.fromCharCode(((c & 31) << 6) | (c2 & 63));
            i += 2;
        } else {
            c2 = str_data.charCodeAt(i+1);
            c3 = str_data.charCodeAt(i+2);
            tmp_arr[ac++] = String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
            i += 3;
        }
    }
    
    return tmp_arr.join('');
}

function searchRecords(obj, strTempId, innerTbaleCnt, parentDivPreFix)
{
	//alert(obj.value);
	var parentContainer = document.getElementById(parentDivPreFix + strTempId);
	parentContainer.innerHTML="";
	
	var len = arrOptFldFiles.length;
	for(var i=0;i<len;i++)
	{
		var arr = explode ("/", base64_decode(arrOptFldFiles[i]));
		var l = arr.length;
		
		var myString = arr[l-1];
		var needle = obj.value;
		
		//alert(myString.toLowerCase() + " " + needle.toLowerCase());
			if (!isNaN(parseInt(strpos(myString.toLowerCase(), needle.toLowerCase()))))
		{
			parentContainer.innerHTML = parentContainer.innerHTML + '<input name="opt_fld_audio['+strTempId+']['+innerTbaleCnt+']" value="'+arrOptFldFiles[i]+'" id="'+myString+'" type="radio">&nbsp;'+myString+'<br>';
		}
	}//-- for.
}

function sortMassUploadBy(key, strTempId, innerTbaleCnt, type, parentDivPreFix, frmName)
{
	
	//alert(type);
	if(key)
	{
		switch(key)
		{
			case "aplhabetic":
							var parentContainer = document.getElementById(parentDivPreFix + strTempId);
							parentContainer.innerHTML="";
							
							var len = arrOptFldFiles.length;
							
							if(type=="asc")
							{
								arrOptFldFiles.sort()
								document.getElementById("id_opfield_sort_" + strTempId).onclick= function(){
										sortMassUploadBy(key, strTempId, innerTbaleCnt, "desc",parentDivPreFix, frmName);
										};
							}
							else
							{
								arrOptFldFiles.reverse()
								document.getElementById("id_opfield_sort_" + strTempId).onclick= function(){
										sortMassUploadBy(key, strTempId, innerTbaleCnt, "asc",parentDivPreFix, frmName);
										};
							}
							
							for(var i=0;i<len;i++)
							{		
							
								var arr = explode ("/", base64_decode(arrOptFldFiles[i]));
								var l = arr.length;
								var myString = arr[l-1];
								parentContainer.innerHTML = parentContainer.innerHTML + '<input name="opt_fld_audio['+strTempId+']['+innerTbaleCnt+']" value="'+arrOptFldFiles[i]+'" id="'+myString+'" type="radio">&nbsp;'+myString+'<br>';
							}//-- for.
							
							break;
							
			case "datewise" :
								var parentContainer = document.getElementById(parentDivPreFix + strTempId);
								parentContainer.innerHTML="";
								var hold = "";
								var len = parseInt(arrOptFldFiles_modifiedDate.length);
								if(type=="asc")
								{
									for (var x=0; x<len;x++)
									{
									 for (var y=0; y<len;y++)
									  {
										
										//alert(arrOptFldFiles_modifiedDate[x] + " < " + arrOptFldFiles_modifiedDate[y]);
										
										//if(type=="asc")
										//{
											if(arrOptFldFiles_modifiedDate[x] < arrOptFldFiles_modifiedDate[y])
											{
												hold = arrOptFldFiles_modifiedDate[x];
												arrOptFldFiles_modifiedDate[x] = arrOptFldFiles_modifiedDate[y];
												arrOptFldFiles_modifiedDate[y] = hold;
	
												hold = arrOptFldFiles_modifiedDate2[x];
												arrOptFldFiles_modifiedDate2[x] = arrOptFldFiles_modifiedDate2[y];
												arrOptFldFiles_modifiedDate2[y] = hold;
												
												hold = arrOptFldFiles[x];
												arrOptFldFiles[x] = arrOptFldFiles[y];
												arrOptFldFiles[y] = hold;
												
											}//-- if.
										/*}
										else
										{
											if(arrOptFldFiles_modifiedDate[x] < arrOptFldFiles_modifiedDate[y])
											{
												hold = arrOptFldFiles_modifiedDate[y];
												arrOptFldFiles_modifiedDate[y] = arrOptFldFiles_modifiedDate[x];
												arrOptFldFiles_modifiedDate[x] = hold;
												
												hold = arrOptFldFiles_modifiedDate2[y];
												arrOptFldFiles_modifiedDate2[y] = arrOptFldFiles_modifiedDate2[x];
												arrOptFldFiles_modifiedDate2[x] = hold;
											}//-- if.
										}*/
									  }//-- for.
									}//-- for.
								}
								
								
								
								if(type=="desc")
								{
									for (var x=0; x<len;x++)
									{
									for (var y=len-1; y>x;y--)
									  {
										
										
										//if(type=="asc")
										//{
											if(arrOptFldFiles_modifiedDate[x] < arrOptFldFiles_modifiedDate[y])
											{
												hold = arrOptFldFiles_modifiedDate[x];
												arrOptFldFiles_modifiedDate[x] = arrOptFldFiles_modifiedDate[y];
												arrOptFldFiles_modifiedDate[y] = hold;
	
												hold = arrOptFldFiles_modifiedDate2[x];
												arrOptFldFiles_modifiedDate2[x] = arrOptFldFiles_modifiedDate2[y];
												arrOptFldFiles_modifiedDate2[y] = hold;
												
												
												hold = arrOptFldFiles[x];
												arrOptFldFiles[x] = arrOptFldFiles[y];
												arrOptFldFiles[y] = hold;
												
											}//-- if.
										/*}
										else
										{
											if(arrOptFldFiles_modifiedDate[x] < arrOptFldFiles_modifiedDate[y])
											{
												hold = arrOptFldFiles_modifiedDate[y];
												arrOptFldFiles_modifiedDate[y] = arrOptFldFiles_modifiedDate[x];
												arrOptFldFiles_modifiedDate[x] = hold;
												
												hold = arrOptFldFiles_modifiedDate2[y];
												arrOptFldFiles_modifiedDate2[y] = arrOptFldFiles_modifiedDate2[x];
												arrOptFldFiles_modifiedDate2[x] = hold;
											}//-- if.
										}*/
									  }//-- for.
									}//-- for.
								}
								
								if(type=="asc")
								{
									document.getElementById("id_opfield_sort_datewise_" + strTempId).onclick= function(){
											sortMassUploadBy(key, strTempId, innerTbaleCnt, "desc",parentDivPreFix, frmName);
											};
								}
								else
								{
									document.getElementById("id_opfield_sort_datewise_" + strTempId).onclick= function(){
											sortMassUploadBy(key, strTempId, innerTbaleCnt, "asc",parentDivPreFix, frmName);
											};
								}
								
								

								
							for (i in arrOptFldFiles_modifiedDate2)
							{		
								var arr = explode ("/", base64_decode(arrOptFldFiles_modifiedDate2[i]));
								var l = arr.length;
								var myString = arr[l-1];
								parentContainer.innerHTML = parentContainer.innerHTML + '<input name="opt_fld_audio['+strTempId+']['+innerTbaleCnt+']" value="'+arrOptFldFiles_modifiedDate2[i]+'" id="'+myString+'" type="radio">&nbsp;'+myString+'<br>';
							}//-- for.

							break;
		}//-- switch.
		if(document.forms[frmName].elements["opt_files_search["+strTempId+"]["+innerTbaleCnt+"]"].value != "")
			searchRecords(document.forms[frmName].elements["opt_files_search["+strTempId+"]["+innerTbaleCnt+"]"], strTempId, innerTbaleCnt, parentDivPreFix);
	}//-- if.
}

function clearSearchRecord(name, strTempId, innerTbaleCnt, parentDivPreFix)
{
	if(document.newbannerform.elements[name] && name)
	{
		document.newbannerform.elements[name].value="";
		searchRecords(document.newbannerform.elements[name], strTempId, innerTbaleCnt, parentDivPreFix);
	}
}

function clearSearchRecord2(name, strTempId, innerTbaleCnt, parentDivPreFix)
{
	if(document.form2.elements[name] && name)
	{
		document.form2.elements[name].value="";
		searchRecords2(document.form2.elements[name], strTempId, innerTbaleCnt, parentDivPreFix);
	}
}

function searchRecords2(obj, strTempId, innerTbaleCnt, parentDivPreFix)
{
	//alert(obj.value);
	var parentContainer = document.getElementById(parentDivPreFix + innerTbaleCnt);
	parentContainer.innerHTML="";
	
	var len = arrOptFldFiles.length;
	for(var i=0;i<len;i++)
	{
		var arr = explode ("/", base64_decode(arrOptFldFiles[i]));
		var l = arr.length;
		
		var myString = arr[l-1];
		var needle = obj.value;
		
		
		//alert(myString.toLowerCase() + "\n" + needle.toLowerCase() + "\n" + arrOptFldFiles[i]);
			if (!isNaN(parseInt(strpos(myString.toLowerCase(), needle.toLowerCase()))))
		{
			parentContainer.innerHTML = parentContainer.innerHTML + '<input name="opt_fld_audio['+strTempId+']['+innerTbaleCnt+']" value="'+arrOptFldFiles[i]+'" id="'+myString+'" type="radio">&nbsp;'+myString+'<br>';
		}
	}//-- for.
}

function sortMassUploadBy2(key, strTempId, innerTbaleCnt, type, parentDivPreFix, frmName)
{
	
	//alert(parentDivPreFix + innerTbaleCnt);
	if(key)
	{
		switch(key)
		{
			case "aplhabetic":
							var parentContainer = document.getElementById(parentDivPreFix + innerTbaleCnt);
							parentContainer.innerHTML="";
							
							var len = arrOptFldFiles.length;
							
							if(type=="asc")
							{
								arrOptFldFiles.sort()
								document.getElementById("id_opfield_sort_" + strTempId).onclick= function(){
										sortMassUploadBy2(key, strTempId, innerTbaleCnt, "desc",parentDivPreFix, frmName);
										};
							}
							else
							{
								arrOptFldFiles.reverse()
								document.getElementById("id_opfield_sort_" + strTempId).onclick= function(){
										sortMassUploadBy2(key, strTempId, innerTbaleCnt, "asc",parentDivPreFix, frmName);
										};
							}
							
							for(var i=0;i<len;i++)
							{		
							
								var arr = explode ("/", base64_decode(arrOptFldFiles[i]));
								var l = arr.length;
								var myString = arr[l-1];
								parentContainer.innerHTML = parentContainer.innerHTML + '<input name="opt_fld_audio['+strTempId+']['+innerTbaleCnt+']" value="'+arrOptFldFiles[i]+'" id="'+myString+'" type="radio">&nbsp;'+myString+'<br>';
							}//-- for.
		
							break;
							
			case "datewise" :
								var parentContainer = document.getElementById(parentDivPreFix + innerTbaleCnt);
								parentContainer.innerHTML="";
								var hold = "";
								var len = parseInt(arrOptFldFiles_modifiedDate.length);
								if(type=="asc")
								{
									for (var x=0; x<len;x++)
									{
									 for (var y=0; y<len;y++)
									  {
										
										//alert(arrOptFldFiles_modifiedDate[x] + " < " + arrOptFldFiles_modifiedDate[y]);
										
										//if(type=="asc")
										//{
											if(arrOptFldFiles_modifiedDate[x] < arrOptFldFiles_modifiedDate[y])
											{
												hold = arrOptFldFiles_modifiedDate[x];
												arrOptFldFiles_modifiedDate[x] = arrOptFldFiles_modifiedDate[y];
												arrOptFldFiles_modifiedDate[y] = hold;
	
												hold = arrOptFldFiles_modifiedDate2[x];
												arrOptFldFiles_modifiedDate2[x] = arrOptFldFiles_modifiedDate2[y];
												arrOptFldFiles_modifiedDate2[y] = hold;
												
												hold = arrOptFldFiles[x];
												arrOptFldFiles[x] = arrOptFldFiles[y];
												arrOptFldFiles[y] = hold;
												
											}//-- if.
										/*}
										else
										{
											if(arrOptFldFiles_modifiedDate[x] < arrOptFldFiles_modifiedDate[y])
											{
												hold = arrOptFldFiles_modifiedDate[y];
												arrOptFldFiles_modifiedDate[y] = arrOptFldFiles_modifiedDate[x];
												arrOptFldFiles_modifiedDate[x] = hold;
												
												hold = arrOptFldFiles_modifiedDate2[y];
												arrOptFldFiles_modifiedDate2[y] = arrOptFldFiles_modifiedDate2[x];
												arrOptFldFiles_modifiedDate2[x] = hold;
											}//-- if.
										}*/
									  }//-- for.
									}//-- for.
								}
								
								
								
								if(type=="desc")
								{
									for (var x=0; x<len;x++)
									{
									for (var y=len-1; y>x;y--)
									  {
										
										
										//if(type=="asc")
										//{
											if(arrOptFldFiles_modifiedDate[x] < arrOptFldFiles_modifiedDate[y])
											{
												hold = arrOptFldFiles_modifiedDate[x];
												arrOptFldFiles_modifiedDate[x] = arrOptFldFiles_modifiedDate[y];
												arrOptFldFiles_modifiedDate[y] = hold;
	
												hold = arrOptFldFiles_modifiedDate2[x];
												arrOptFldFiles_modifiedDate2[x] = arrOptFldFiles_modifiedDate2[y];
												arrOptFldFiles_modifiedDate2[y] = hold;
												
												hold = arrOptFldFiles[x];
												arrOptFldFiles[x] = arrOptFldFiles[y];
												arrOptFldFiles[y] = hold;
												
											}//-- if.
										/*}
										else
										{
											if(arrOptFldFiles_modifiedDate[x] < arrOptFldFiles_modifiedDate[y])
											{
												hold = arrOptFldFiles_modifiedDate[y];
												arrOptFldFiles_modifiedDate[y] = arrOptFldFiles_modifiedDate[x];
												arrOptFldFiles_modifiedDate[x] = hold;
												
												hold = arrOptFldFiles_modifiedDate2[y];
												arrOptFldFiles_modifiedDate2[y] = arrOptFldFiles_modifiedDate2[x];
												arrOptFldFiles_modifiedDate2[x] = hold;
											}//-- if.
										}*/
									  }//-- for.
									}//-- for.
								}
								
								if(type=="asc")
								{
									document.getElementById("id_opfield_sort_datewise_" + strTempId).onclick= function(){
											sortMassUploadBy2(key, strTempId, innerTbaleCnt, "desc",parentDivPreFix, frmName);
											};
								}
								else
								{
									document.getElementById("id_opfield_sort_datewise_" + strTempId).onclick= function(){
											sortMassUploadBy2(key, strTempId, innerTbaleCnt, "asc",parentDivPreFix, frmName);
											};
								}
								
								

								
							for (i in arrOptFldFiles_modifiedDate2)
							{		
								var arr = explode ("/", base64_decode(arrOptFldFiles_modifiedDate2[i]));
								var l = arr.length;
								var myString = arr[l-1];
								parentContainer.innerHTML = parentContainer.innerHTML + '<input name="opt_fld_audio['+strTempId+']['+innerTbaleCnt+']" value="'+arrOptFldFiles_modifiedDate2[i]+'" id="'+myString+'" type="radio">&nbsp;'+myString+'<br>';
							}//-- for.

							break;
		}//-- switch.
		if(document.forms[frmName].elements["opt_files_search["+strTempId+"]["+innerTbaleCnt+"]"].value != "")
			searchRecords2(document.forms[frmName].elements["opt_files_search["+strTempId+"]["+innerTbaleCnt+"]"], strTempId, innerTbaleCnt, parentDivPreFix);
	}//-- if.
}